<style>
.node_label_white {
    color: white;
}

#connection_error {
    color: red;
}

</style>

<script type="text/x-red" data-template-name="justeat-cycles">
    <div class="form-row" id="connection_error" style="display: none;">
        <label><i class="fa fa-wifi"></i> ERROR</label>
        <span>This node requires an internet connection.</span>
    </div>
    <div class="form-row">
        <label for="node-input-name"><i class="icon-tag"></i> Name</label>
        <input type="text" id="node-input-name" placeholder="Name">
    </div>
    <div class="form-row">
        <label for="node-input-source">Data Type</label>
        <select id="node-input-source">
            <option value="station">Specific docking station</options>
            <option value="service">Whole service</option>
        </select>
    </div>
    <div class="form-row" id="input-station">
        <label for="node-input-station">Docking station</label>
        <select id="node-input-station">
        </select>
        <a href="https://edinburghcyclehire.com/stations">Map of stations</a>
    </div>
    <div class="form-row" id="input-station_data">
        <label for="node-input-station_data">Output</label>
        <select id="node-input-station_data">
          <option value="num_bikes_available">Number of bikes available</options>
          <option value="num_docks_available">Number of docks available</options>
        </select>
    </div>
    <div class="form-row" id="input-service_data" style="display: none;">
        <label for="node-input-service_data">Output</label>
        <select id="node-input-service_data">
          <option value="num_active_trips">Number of active trips</options>
          <option value="num_trips_today">Number of trips today</options>
          <option value="num_users_today">Number of users today</options>
          <option value="median_trip_duration_today_seconds">Median trip duration today (s)</options>
        </select>
    </div>
</script>

<script type="text/x-red" data-help-name="justeat-cycles">
    <p>A node that provides live data from the Edinburgh Just Eat cycle hire service.</p>

    <h3>Outputs</h3>
    <ol class="node-ports">
      <dl class="message-properties">
        <dt>payload <span class="property-type">number</span></dt>
        <dd>Contains the numerical value for the selected data source.</dd>
      </dl>
    </ol>

    <h3>Details</h3>
    <p>Start by selecting an output from the node's propereties menu (double click on the node).</p>
    <p>The node outputs data every 10 seconds (the update frequency of the source data).</p>

    <h3>References</h3>
    <ul>
      <li><a href="https://edinburghcyclehire.com/open-data/realtime">Just Eat API</a> - overview of API</li>
      <li><a href="https://github.com/NABSA/gbfs/blob/master/gbfs.md">GBFS format</a> - the General Bikeshare Feed Specification</li>
    </ul>
</script>

<script type="text/javascript">
    RED.nodes.registerType('justeat-cycles',{
        category: 'Live Data',
        color: '#EB0028',
        defaults: {
            name: {value:""},
            station: {value:""},
            source: {value: ""},
            service_data: {value: ""},
            station_data: {value: ""},
            station_plaintext: {value: ""},
            station_data_plaintext: {value: ""},
            service_data_plaintext: {value: ""}
        },
        inputs:0,
        outputs:1,
        icon: "font-awesome/fa-bicycle",
        label: function() {
            return this.name||"JustEat cycles";
        },
        labelStyle: "node_label_white",
        oneditprepare: function() {
            var stations = {}
            $.getJSON("https://gbfs.urbansharing.com/edinburghcyclehire.com/station_information.json")
              .done(data => {
                $("#connection_error").hide();
                stations = data.data.stations;
                stations.sort(function (a, b) {
                    return a.name.localeCompare(b.name);
                });
                stations.forEach(s => {
                  var o = new Option(s.name, s.station_id);
                  $(o).html(s.name);
                  $("#node-input-station").append(o);
                });
                if (!this.station){
                  this.station = stations[0].station_id;
                }
              })
              .fail(function( jqxhr, textStatus, error ) {
                $("#connection_error").show();
                var err = textStatus + ", " + error;
                console.log( "Request Failed: " + err );
              });

            $("#node-input-station").val(this.station);
            $("#node-input-station_data").val(this.station_data || "num_bikes_available");
            $("#node-input-service_data").val(this.service_data || "num_active_trips");
            $("#node-input-source").change(function() {
                if ($(this).val() == "station") {
                    $("#input-station").show();
                    $("#input-station_data").show();
                    $("#input-service_data").hide();
                } else {
                    $("#input-station").hide();
                    $("#input-station_data").hide();
                    $("#input-service_data").show();
                }
            });
        },
        oneditsave: function(){
          this.station_plaintext = $("#node-input-station option:selected").text();
          this.station_data_plaintext = $("#node-input-station_data option:selected").text();
          this.service_data_plaintext = $("#node-input-service_data option:selected").text();
        }
    });
</script>
